Namespace SSTP.Core

    ''' <summary>
    ''' SSTPNGXgf[^NX
    ''' </summary>
    ''' <remarks></remarks>
    Public Class RequestData

        Private m_Hwnd As System.IntPtr
        Private m_Method As String = "SEND"
        Private m_Command As String = ""
        Private m_Sender As String
        Private m_Marker As String
        Private m_Option As String = "notranslate"
        Private m_Charset As String = "Shift_JIS"
        Private m_Script As String = "\e"
        Private m_AsGhost As String
        Private m_IfGhost As String
        Private m_XBottleIfGhost As String

        '------------------------
        ' RXgN^
        '------------------------

        Public Sub New(ByVal hwnd As System.IntPtr, ByVal sender As String, ByVal marker As String)
            m_Method = "SEND"
            m_Hwnd = hwnd
            m_Sender = sender
            m_Marker = marker
        End Sub

        Public Sub New(ByVal sstpString As String)
            analyze(sstpString)
        End Sub

        '------------------------
        ' pubNtB[h
        '------------------------

        Public Property Hwnd() As System.IntPtr
            Get
                Return m_Hwnd
            End Get
            Set(ByVal value As System.IntPtr)
                m_Hwnd = value
            End Set
        End Property

        Public Property Script() As String
            Get
                Return m_Script
            End Get
            Set(ByVal value As String)
                m_Method = "SEND"
                m_Script = value.Trim
                If Not m_Script.EndsWith("\e") Then m_Script = m_Script & "\e"
            End Set
        End Property

        Public Property IfGhost() As String
            Get
                Return m_IfGhost
            End Get
            Set(ByVal value As String)
                m_IfGhost = value
            End Set
        End Property

        Public Property AsGhost() As String
            Get
                If m_AsGhost IsNot Nothing Then
                    Return m_AsGhost
                Else
                    If m_XBottleIfGhost IsNot Nothing Then Return m_XBottleIfGhost
                    Return Nothing
                End If
            End Get
            Set(ByVal value As String)
                m_AsGhost = value
                Dim i As Integer = m_AsGhost.IndexOf(","c)
                If i >= 0 Then m_XBottleIfGhost = m_AsGhost.Substring(0, i) Else m_XBottleIfGhost = m_AsGhost
            End Set
        End Property

        Public Property XBottleIfGhost() As String
            Get
                If m_XBottleIfGhost IsNot Nothing Then
                    Return m_XBottleIfGhost
                Else
                    If m_AsGhost IsNot Nothing Then
                        Dim i As Integer = m_AsGhost.IndexOf(","c)
                        If i >= 0 Then Return m_AsGhost.Substring(0, i) Else Return m_AsGhost
                    End If
                    Return Nothing
                End If
            End Get
            Set(ByVal value As String)
                m_AsGhost = value
                Dim i As Integer = m_AsGhost.IndexOf(","c)
                If i >= 0 Then m_XBottleIfGhost = m_AsGhost.Substring(0, i) Else m_XBottleIfGhost = m_AsGhost
            End Set
        End Property

        Public Property Ghost() As String
            Get
                If m_AsGhost IsNot Nothing Then Return m_AsGhost
                If m_XBottleIfGhost IsNot Nothing Then
                    If m_IfGhost IsNot Nothing Then
                        If m_IfGhost.StartsWith(m_XBottleIfGhost) Then
                            Return m_IfGhost
                        Else
                            Return m_XBottleIfGhost
                        End If
                    End If
                End If
                If m_IfGhost IsNot Nothing Then Return m_IfGhost
                Return Nothing
            End Get
            Set(ByVal value As String)
                m_AsGhost = value
                m_IfGhost = value
                Dim i As Integer = m_AsGhost.IndexOf(","c)
                If i >= 0 Then m_XBottleIfGhost = m_AsGhost.Substring(0, i) Else m_XBottleIfGhost = m_AsGhost
            End Set
        End Property

        Public Property Command() As String
            Get
                Return m_Command
            End Get
            Set(ByVal value As String)
                m_Method = "EXECUTE"
                m_Command = value
            End Set
        End Property

        '------------------------
        ' pubN\bh
        '------------------------

        ''' <summary>\(I[o[Ch)</summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Overrides Function toString() As String
            Return toText()
        End Function

        ''' <summary>
        ''' Mp̃eLXgɐ܂B
        ''' </summary>
        ''' <returns>s܂ޕ</returns>
        ''' <remarks></remarks>
        Public Function toText() As String
            Dim s As New System.Text.StringBuilder
            If m_Method = "SEND" Then
                If m_Script.Length > 0 Then
                    s.Append("SEND SSTP/1.4" & vbCrLf)
                    If m_Sender IsNot Nothing Then
                        s.Append("Sender: " & m_Sender & vbCrLf)
                    End If
                    If m_IfGhost IsNot Nothing Then
                        s.Append("IfGhost: " & m_IfGhost & vbCrLf)
                    End If
                    If m_AsGhost IsNot Nothing Then
                        s.Append("AsGhost: " & m_AsGhost & vbCrLf)
                    End If
                    If m_XBottleIfGhost IsNot Nothing Then
                        s.Append("X-Bottle-IfGhost: " & m_XBottleIfGhost & vbCrLf)
                    End If
                    s.Append("Script: " & m_Script & vbCrLf)
                    s.Append("HWnd: " & m_Hwnd.ToString & vbCrLf)
                    If m_Marker IsNot Nothing Then
                        s.Append("Marker: " & m_Marker & vbCrLf)
                    End If
                    s.Append("Option: " & m_Option & vbCrLf)
                    s.Append("Charset: " & m_Charset & vbCrLf)
                    Return s.ToString
                Else
                    Return ""
                End If
            ElseIf m_Method = "EXECUTE" Then
                If m_Command.Length > 0 Then
                    s.Append("EXECUTE SSTP/1.3" & vbCrLf)
                    If m_Sender IsNot Nothing Then
                        s.Append("Sender: " & m_Sender & vbCrLf)
                    End If
                    s.Append("Command:" & m_Command & vbCrLf)
                    s.Append("Charset: " & m_Charset & vbCrLf)
                    Return s.ToString
                Else
                    Return ""
                End If
            Else
                Return ""
            End If
        End Function

        '------------------------
        ' vCx[g֐
        '------------------------

        'SSTP񂩂烊NGXg𐶐(T[o[p)
        Private Function analyze(ByVal SSTPString As String) As Boolean
            m_Hwnd = CType(Val(CutDataOnSSTPString(SSTPString, "HWnd:")), System.IntPtr)
            m_Charset = CutDataOnSSTPString(SSTPString, "Charset:")
            If m_Hwnd <> 0 Then
                If SSTPString.StartsWith("NOTIFY") Then
                    m_Method = "NOTIFY"
                    Return True
                End If
                If SSTPString.StartsWith("SEND") Then
                    m_Method = "SEND"
                    m_Sender = CutDataOnSSTPString(SSTPString, "Sender:")
                    m_IfGhost = CutDataOnSSTPString(SSTPString, "IfGhost:")
                    m_AsGhost = CutDataOnSSTPString(SSTPString, "AsGhost:")
                    m_XBottleIfGhost = CutDataOnSSTPString(SSTPString, "X-Bottle-IfGhost:")
                    m_Script = CutDataOnSSTPString(SSTPString, "Script:")
                    m_Marker = CutDataOnSSTPString(SSTPString, "Marker:")
                    m_Option = CutDataOnSSTPString(SSTPString, "Option:")
                    Return True
                End If
                If SSTPString.StartsWith("EXECUTE") Then
                    m_Method = "EXECUTE"
                    m_Command = CutDataOnSSTPString(SSTPString, "Command:")
                    Return True
                End If
            End If
            Return False
        End Function

        'SSTP񂩂oėp֐
        Private Shared Function CutDataOnSSTPString _
       (ByVal sstpString As String, ByVal header As String) As String
            Dim i As Integer, j As Integer
            Dim s As String
            header = vbCrLf & header
            i = sstpString.IndexOf(header)
            If i < 0 Then Return ""
            i = i + header.Length
            j = sstpString.IndexOf(vbCrLf, i)
            If j < 0 Then
                s = sstpString.Substring(i).Trim
            Else
                s = sstpString.Substring(i, j - i).Trim
            End If
            If s.StartsWith(":") Then s = s.Substring(1).Trim
            Return s
        End Function
    End Class

End Namespace
